#!/usr/bin/env python3


import re
import sys
import glob

HEADER = """
# Elrond reference

This is a quick reference for the Elrond APIs, mostly acting as a list of
what's in Elrond and a quick way to get to things.

Note, this file was generated by `%(arg0)s`:

``` bash
$ %(args)s
```
""" % dict(arg0=sys.argv[0], args=' '.join(sys.argv))

LIBRARIES = [
    ("Elrond", "elrond", "#elrond-refdir",
        "The ELF loader and configurator, see "
        "[elrond/README.md](elrond/README.md).", [
            ("Elrond constants", [
                ("h", "elrond.h", "(?:#define +([\w]+) | *([\w]+) *=.*,)")
            ]),
            ("Elrond macros", [
                ("h", "elrond.h", "#define +([\w]+)\(")
            ]),
            ("Elrond functions", [
                ("h", "elrond.h", "[\w].*?([\w]+)\("),
                ("c", "*.c", "[\w].*?([\w]+)\("),
            ]),
            ("Elrond endpoint functions", [
                ("h", "elrond_ep.h", "[\w].*?([\w]+)\("),
                ("c", "*.c", "[\w].*?([\w]+)\("),
            ]),
            ("Elrond process functions", [
                ("h", "elrond_process.h", "[\w].*?([\w]+)\("),
                ("c", "*.c", "[\w].*?([\w]+)\("),
            ]),
            ("Elrond ring-buffer functions", [
                ("h", "elrond_ring.h", "[\w].*?([\w]+)\("),
                ("c", "*.c", "[\w].*?([\w]+)\("),
            ]),
        ]),
    ("Elrond helpers", "elrond_helpers", "#elrond-helpers-refdir",
        "Helpers for C processes, see "
        "[elrond_helpers/README.md](elrond_helpers/README.md).", [
            ("Elrond helper constants", [
                ("h", "elrond_helpers.h", "(?:#define +([\w]+) | *([\w]+) *=.*,)")
            ]),
            ("Elrond helper macros", [
                ("h", "elrond_helpers.h", "#define +([\w]+)\(")
            ]),
            ("Elrond helper functions", [
                ("h", "elrond_helpers.h", "[\w].*?([\w]+)\("),
                ("c", "*.c", "[\w].*?([\w]+)\("),
            ]),
            ("Elrond helper ring-buffer macros", [
                ("h", "elrond_ring.h", "#define +([\w]+)\(")
            ]),
            ("Elrond helper ring-buffer functions", [
                ("h", "elrond_ring.h", "[\w].*?([\w]+)\("),
                ("c", "*.c", "[\w].*?([\w]+)\("),
            ]),
            ("Elrond helper weak functions", [
                ("c", "*.c", "[\w].*?(__elrond_(?!init)(?!sys_)(?![\w]+0)[\w]+)\("),
            ]),
            ("Elrond helper syscalls", [
                ("c", "*.c", "[\w].*?(__elrond_sys_[\w]+)\("),
            ]),
        ]),
    ("Elrond Rust helpers", "elrond_rust_helpers", "#elrond-rust-helpers-refdir",
        "Helpers for Rust processes, see "
        "[elrond_rust_helpers/README.md](elrond_rust_helpers/README.md).", [
            ("Elrond Rust helper constants", [
                ("rs", "src/lib.rs", "pub const (?!fn)([\w]+)"),
            ]),
            ("Elrond Rust helper macros", [
                ("rs", "src/lib.rs", "pub use elrond_helpers_macros::([\w]+)"),
            ]),
            ("Elrond Rust helper functions", [
                ("rs", "src/lib.rs", " *pub [^:]*fn [^:]*?([\w]+)\("),
            ]),
            ("Elrond Rust helper ring-buffer macros", [
                ("rs", "src/ring.rs", "pub use elrond_helpers_macros::([\w]+)"),
            ]),
            ("Elrond Rust helper ring-buffer functions", [
                ("rs", "src/ring.rs", " *pub [^:]*fn [^:]*?([\w]+)\(",
                    "::", "impl ([\w]+) {", "}"),
            ]),
        ]),
    ("libsel4rustbindings", "libsel4rustbindings", "#libsel4rustbindings-refdir",
        "Simple Rust bindings for libsel4, see "
        "[seL4's documentation](https://docs.sel4.systems/projects/sel4/api-doc.html).", [])
]

def write_libraries(f):
    f.writeln("### Libraries")
    f.writeln()
    for name, dir, ref, _, _ in LIBRARIES:
        f.writeln(
            "- [%(name)s](%(ref)s) ([ref](%(ref)s)/[dir](%(dir)s))"
            % dict(name=name, dir=dir, ref=ref))
    f.writeln()

def write_library(f, library):
    name, dir, ref, note, lists = library
    f.writeln(
        "### %(name)s ([ref](%(ref)s)/[dir](%(dir)s))"
        % dict(name=name, dir=dir, ref=ref))
    f.writeln()
    f.writeln(note.strip())
    f.writeln()

    for l_name, l_refs in lists:
        f.writeln("##### %(name)s" % dict(name=l_name))
        f.writeln()

        # find references
        matches = []
        for r_name, r_glob, r_pattern, *r_ns in l_refs:
            r_pattern = re.compile(r_pattern)
            if r_ns:
                ns_join, ns_start, ns_end = r_ns
                ns_start = re.compile(ns_start)
                ns_end = re.compile(ns_end)
            matches_ = []
            ns_name = None
            for path in glob.glob(
                    "%(dir)s/%(glob)s"
                    % dict(dir=dir, glob=r_glob)):
                with open(path) as r_f:
                    for lineno, line in enumerate(r_f):
                        m = r_pattern.match(line)
                        if m:
                            name = next(g for g in m.groups() if g is not None)
                            if not name.endswith("_"):
                                if ns_name is not None:
                                    name = ns_join.join([ns_name, name])
                                matches_.append((name, path, lineno+1))
                        if r_ns:
                            if ns_name is None:
                                m = ns_start.match(line)
                                if m:
                                    ns_name = next(g for g in m.groups() if g is not None)
                            else:
                                m = ns_end.match(line)
                                if m:
                                    ns_name = None

            matches.append(matches_)

        # write references
        for m_name, m_path, m_lineno in matches[0]:
            f.write(
                "- [`%(name)s`](%(path)s#L%(lineno)s)"
                % dict(name=m_name, path=m_path, lineno=m_lineno))
            more_than_one = False
            for (r2_name, _, _), matches_ in zip(l_refs[1:], matches[1:]):
                for (m2_name, m2_path, m2_lineno) in matches_:
                    if m2_name == m_name:
                        if not more_than_one:
                            f.write(
                                " ([%(name)s](%(path)s#L%(lineno)s)"
                                % dict(name=l_refs[0][0], path=m_path, lineno=m_lineno))
                            more_than_one = True
                        f.write(
                            "/[%(name)s](%(path)s#L%(lineno)s)"
                            % dict(name=r2_name, path=m2_path, lineno=m2_lineno))
            if more_than_one:
                f.write(")")
            f.writeln()
        
        f.writeln()

def main(output=None):
    with open(output, 'w') as f:
        def writeln(s=''):
            f.write(s)
            f.write('\n')
        f.writeln = writeln

        # write our header
        f.writeln(HEADER.strip())
        f.writeln()

        # write the libraries
        write_libraries(f)

        # write each library section
        for library in LIBRARIES:
            write_library(f, library)

        

if __name__ == "__main__":
    import argparse
    import sys
    parser = argparse.ArgumentParser(
        description="Generates REFERENCE.md.")
    parser.add_argument('-o', '--output',
        help=".c file to write.")
    sys.exit(main(**{k: v
        for k, v in vars(parser.parse_args()).items()
        if v is not None}))
    
